import java.awt.*;

public class BarMeter1 extends Component {

    // Double Buffering pC[W
    transient protected Image image = null;
    transient protected Graphics graphics = null;

    // ʂ̑傫Ɋ֘AvpeB
    protected int width = 0;
    protected int height = 0;

    // [^̍ŏ/ől
    protected double minimum = 0;
    protected double maximum = 100;

    // [^wl
    protected double value = 0;

    public BarMeter1(){
        super();
    }

    public Dimension getPreferredSize(){
        return getMinimumSize();
    }

    public Dimension getMinimumSize(){
        return new Dimension(50, 100);
    }

    public void setValue(double value){
        this.value = value;
        repaint();
    }

    // o[̕`
    protected void drawBar(Graphics g, double value){

        // wl̑ΒlZo
        double val = (value - minimum)/ (maximum - minimum);

        // Ot̍ɕϊ
        val *= height;

        int y = height - (int)val;
        int h = (int)val;

        // o[̐Fݒ
        g.setColor(Color.yellow);

        // o[`
        g.fillRect(0, y, width, h);
    }

    public void update(Graphics g){
        // ʂ̃NA͍sȂ
        paint(g);
    }

    public void createBufferImage(){
        // Avbg̃TCY
        Dimension size = this.getSize();
        width = size.width;
        height = size.height;

        if(width != 0 && height != 0){
            // C[W̐
            image = this.createImage(width, height);
            graphics = image.getGraphics();
        }
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        if(image == null){
            createBufferImage();
        }

        // wiFœhԂ
        graphics.setColor(this.getBackground());
        graphics.fillRect(0, 0, width, height);

        // o[̕`
        drawBar(graphics, value);

        // C[Wobt@̕`
        g.drawImage(image, 0, 0, width, height, this);
    }
}
