import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class BarMeterApplet4_1 extends Applet implements Runnable {

    BarMeter3 meter;
    Frame frame;

    public void init(){
        frame = new TestFrame("BarMeter");
        frame.setLayout(new BorderLayout());

        meter = new BarMeter3();
        frame.add(meter, BorderLayout.CENTER);

        frame.setSize(100, 200);
        frame.setVisible(true);

        frame.addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e){
                frame.setVisible(false);
                frame.dispose();
            }
        });

        meter.setMinimum(10);
        meter.setMaximum(50);
        
        meter.setForeground(Color.red);
        meter.setBackground(Color.black);
    }

    public void start(){
        Thread thread = new Thread(this);
        thread.start();
    }

    public void run(){
        while(true){
            for(int i = 10 ; i < 50 ; i++){
                meter.setValue((double)i);

                try{
                    Thread.sleep(100);
                }catch(InterruptedException ex){
                    return;
                }
            }
        }
    }
}
