import java.util.*;

public class DataReader implements Runnable {
    volatile protected Thread myThread;
    protected long timeBase = 1000; // mSec
    protected boolean active = false; // ꎞ~p̃tO
    protected int value = 0; // ĎΏۋ@킩擾lێ
    private Vector dataListeners = new Vector();        // XiIuWFNgQێ

    // RXgN^
    public DataReader() {
        super();
        myThread = new Thread(this);
        myThread.start();
    }
        
    // Xio^\bh
    public synchronized void addDataChangeListener(DataChangeListener vl) {
        dataListeners.addElement(vl);
    }
        
    // ĎΏۋ@킩l擾
    protected int getMonitoredValue() {
        //Ƃ肠A_ɒl𐶐ĕԂB
        return (int) (Math.random() * 100);                
    }
        
    public long getTimeBase() {
        return timeBase;
    }
        
    public int getValue() {
        return value;
    }
        
    public boolean isActive() {
        return active;
    }
        
    // @킩l擾valueɐݒ肷BăCxg𔭐MB
    public void readAndSetValue() {
        int newVal = getMonitoredValue();
        if (value == newVal) return;

        value = newVal;                
        DataChangeEvent e = new DataChangeEvent(this, value); // Cxg̐
        Vector cloneVec ;
        synchronized (this) {
            cloneVec = (Vector)dataListeners.clone();
        }
        // Xio^ĂeIuWFNg̃Cxg\bhNB
        for (int i=0; i<cloneVec.size(); i++) {
            ((DataChangeListener)cloneVec.elementAt(i)).dataChanged(e);
        }                
    }
        
    // Xio^\bh
    public synchronized void removeDataChangeListener(DataChangeListener vl) {
        dataListeners.removeElement(vl);
    }
        
    // RunnableC^tF[X̃\bh
    public void run() {
        Thread ct = Thread.currentThread();
        long currentMillis = System.currentTimeMillis();
        while (myThread == ct) {
            try {
                // timeBasereadAndSetValue\bhNB
                myThread.sleep(currentMillis+timeBase-System.currentTimeMillis());
                if (!active) {
                    synchronized (this) {
                        while (!active && myThread == ct) {
                            wait();
                            if (myThread != ct)        return;
                        }
                    }
                }
                currentMillis = System.currentTimeMillis();
                readAndSetValue();
            } catch(InterruptedException e) {
                return; 
            }
        }
    }
        
    public synchronized void setActive(boolean active) {
        if (!this.active && active) {
            this.active = true;
            notifyAll();
        } else if (this.active && !active) {
            this.active = false;
        }
    }
        
    public void setTimeBase(long millis) {
        if (millis > 0) {
            timeBase = millis;
        }
    }
        
    // XbhsI邽߂̃\bh
    protected synchronized void stop() {
        Thread th = myThread;
        myThread = null;
        th.interrupt();
    }
}
